=== doc/CMakeLists.txt ===
add_subdirectory(doxygen)
add_subdirectory(sphinxman)
add_subdirectory(cloc)
