=== lib/CMakeLists.txt ===
set(Folders2Copy "basis" "databases" "grids" "plugin" "python" "quadratures" "efpfrag" "scripts")
INSTALL(
  DIRECTORY ${Folders2Copy} 
  DESTINATION ${CMAKE_INSTALL_PREFIX}/share/psi
  USE_SOURCE_PERMISSIONS
  PATTERN ".pyc" EXCLUDE
)
