=== plugins/CMakeLists.txt ===
add_subdirectory(aointegrals)
add_subdirectory(backtrans)
add_subdirectory(mointegrals)
add_subdirectory(mollerplesset2)
add_subdirectory(sointegrals)
add_subdirectory(skeleton)
