=== debian/changelog ===
psi4 (1:0.3-5) unstable; urgency=medium

  * Fix FTBFS with perl 5.22, thanks gregor herrmann. (Closes: #810017)
  * Update debian/watch, remove debian/get-orig-source.sh and
    debian/README.source since upstream moved to GitHub.
  * Update debian/copyright: remove one unnecessary item, add two items,
    fix license short names to make Lintian happy.
  * Add debian/clean to fix FTBFSx2.

 -- Graham Inggs <ginggs@debian.org>  Tue, 12 Jan 2016 17:10:34 +0200

psi4 (1:0.3-4) unstable; urgency=medium

  * Update build dependencies for GSL 2, change libgsl0-dev to libgsl-dev,
    thanks Bas Couwenberg. (Closes: #807236)
  * Add myself to uploaders.

 -- Graham Inggs <ginggs@debian.org>  Thu, 17 Dec 2015 09:58:13 +0200

psi4 (1:0.3-3) unstable; urgency=medium

  * debian/rules (override_dh_auto_build): Fix building of manual.
  * debian/patches/system_libint.patch: New patch, skips building of the
    internal libint and uses the system-provided one.
  * debian/control (Build-Depends): Added libint-dev.
  * debian/rules (override_dh_auto_configure): Add -DEXPLICIT_LIBS option.
  * debian/rules (override_dh_auto_install): Create example directory at start
    and install example data under debian/tmp.
  * debian/rules (override_dh_auto_install): Fix installation of HTML
    documentation.
  * debian/psi4.install: Install example psi4rc. 
  * debian/psi4-data.install: Install HTML documentation and example inputs.
  * debian/psi4-data.links: Removed.

 -- Michael Banck <mbanck@debian.org>  Thu, 01 Oct 2015 10:57:40 +0200

psi4 (1:0.3-2) unstable; urgency=medium

  * debian/patches/gcc5_compile_error.patch: New patch, fixes compile errors
    with g++-5 on various architectures, taken from upstream commit de1fc3ed.
  * debian/rules (override_dh_auto_install-arch,
  * override_dh_auto_install-indep): Combine both into override_dh_auto_install
    again, to fix Arch:all building.
  * debian/rules (override_dh_auto_install): Remove all byte-compiled python
    files from python data directory.

 -- Michael Banck <mbanck@debian.org>  Wed, 23 Sep 2015 12:12:19 +0200

psi4 (1:0.3-1) unstable; urgency=medium

  * New upstream prerelease.
  * debian/patches/git_version_fix.patch: New patch, fixes a build failure for
    release tarballs if GIT_VERSION is not defined, taken from upstream commit
    1b91513b.
  * debian/control (Build-Depends): Replaced autotools-dev with cmake.
  * debian/control (Build-Depends): Added libboost-chrono-dev and
    libboost-timer-dev.
  * debian/rules (override_dh_auto_configure): Remove autoconf-specific
    options, and add CMAKE_BUILD_TYPE=RelWithDebInfo define.
  * debian/rules (PSI_SCRATCH, SCRATCH): Removed.
  * debian/rules (override_dh_auto_clean): Update accordingly.
  * debian/rules (override_dh_auto_test): Create scratch directory and run
    `ctest -L quicktests' as testsuite.
  * debian/rules (OMPI_MCA_orte_rsh_agent): New variable.
  * debian/rules (override_dh_auto_install-indep): Remove samples from data
    directory.
  * debian/control (Build-Depends): Added libchemps2-dev.
  * debian/rules: Remove autotools_dev option from dh.
  * debian/rules (override_dh_auto_configure): Add -DENABLE_CHEMPS2 and
    -DCHEMPS2_ROOT options.
  * debian/control (Build-Depends): Added libhdf5-dev and libgsl0-dev.
  * debian/control (Description): Add DMRG.
  * debian/rules (override_dh_auto_test): Also run DMRG tests.
  * debian/upstream: Move to ...
  * debian/upstream/metadata: ... here.
  * debian/control (Standards-Version): Bumped to 3.9.6.

 -- Michael Banck <mbanck@debian.org>  Tue, 22 Sep 2015 19:00:36 +0200

psi4 (4.0~beta5+dfsg-2) unstable; urgency=low

  * debian/rules (DEB_BUILD_MULTIARCH): New variable, populated from
    dpkg-architecture.
  * debian/rules (override_dh_auto_configure): Added --with-boost-libdir.
  * debian/rules (override_dh_auto_install): Split up into
    override_dh_auto_install-arch and override_dh_auto_install-indep (Closes:
    #732044).
  * debian/README.source: New file.

 -- Michael Banck <mbanck@debian.org>  Sat, 14 Dec 2013 20:00:46 +0100

psi4 (4.0~beta5+dfsg-1) unstable; urgency=low

  * Initial Upload of psi4, based on psi3 packaging.

 -- Michael Banck <mbanck@debian.org>  Sun, 03 Nov 2013 17:43:51 +0100
