=== debian/control ===
Source: psi4
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>,
           Graham Inggs <ginggs@debian.org>
Build-Depends: cmake,
               debhelper (>> 8),
	       dvipng,
	       gfortran,
               libblas-dev,
	       libboost-chrono-dev,
	       libboost-filesystem-dev,
               libboost-python-dev,
               libboost-regex-dev,
               libboost-serialization-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libboost-timer-dev,
	       libchemps2-dev,
	       libgsl-dev,
	       libhdf5-dev,
	       libint-dev,
               liblapack-dev,
	       python-dev,
               python-numpy,
	       python-sphinx,
	       texlive-latex-extra
Standards-Version: 3.9.6
Homepage: http://www.psicode.org/
Vcs-Browser: http://anonscm.debian.org/viewvc/debichem/unstable/psi4/
Vcs-Svn: svn://anonscm.debian.org/debichem/unstable/psi4/

Package: psi4
Architecture: any
Depends: psi4-data (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Quantum Chemical Program Suite
 PSI4 is an ab-initio quantum chemistry program.  It is especially designed to
 accurately compute properties of small to medium molecules using highly
 correlated techniques. PSI4 is the parallelized successor of PSI3 and includes
 many state-of-the-art theoretical methods.
 .
 It can compute energies and gradients for the following methods:
  * Restricted, unrestricted and general restricted open shell Hartree-Fock
    (RHF/ROHF)
  * Restricted, unrestricted and general restricted open shell
    Densitry-Functional Theory, including density-fitting (DF-DFT)
  * Density Cumulant Functional Theory (DCFT)
  * Closed-shell Density-fitted Moeller-Plesset perturbation theory (DF-MP2)
  * Unrestricted Moeller-Plesset perturbation theory (MP2)
  * Orbital-Optimized MP2 theory (OMP2)
  * Third order Moeller-Plesset perturbation theory (MP3)
  * Orbital-Optimized MP3 theory (OMP3)
  * Coupled-cluster singles doubles (CCSD)
  * Coupled-cluster singles doubles with perturbative triples (CCSD(T))
    (only for unrestricted (UHF) reference wavefunctions)
  * Equation-of-motion coupled-cluster singles doubles (EOM-CCSD)
 .
 Additionally, it can compute energies for the following methods:
  * Closed/open shell Moeller-Plesset perturbation theory (MP2)
  * Spin-component scaled MP2 theory (SCS-MP2)
  * Fourth order Moeller-Plesset perturbation theory (MP4)
  * Density-fitted symmetry-adapted perturbation theory (DF-SAPT)
  * Multireference configuration-interaction (MRCI)
  * Closed-shell Density-fitted coupled-cluster singles doubles (DF-CCSD)
  * Closed-shell Density-fitted Coupled-cluster singles doubles with
    perturbative triples (DF-CCSD(T))
  * Second/third-order approximate coupled-cluster singles doubles (CC2/CC3)
  * Mukherjee Multireference coupled-cluster singles doubles theory (mk-MRCCSD)
  * Mukherjee Multireference coupled-cluster singles doubles with perturbative
    triples theory (mk-MRCCSD(T))
  * Second order algebraic-diagrammatic construction theory (ADC(2))
  * Quadratic configuration interaction singles doubles (QCISD)
  * Quadratic configuration interaction singles doubles with perturbative
    triples (QCISD(T))
  * Density Matrix Renormalization Group SCF (DMRG-SCF) and CI (DMRG-CI)
 .
 Further features include:
  * Flexible, modular and customizable input format via python
  * Excited state calculations with the EOM-CC2/CC3, EOM-CCSD, ADC(2), MRCI and
    mk-MRCC methods
  * Utilization of molecular point-group symmetry to increase efficiency
  * Internal coordinate geometry optimizer
  * Harmonic frequencies calculations (via finite differences)
  * Potential surface scans 
  * Counterpoise correction
  * One-electron properties like dipole/quadrupole moments, transition dipole
    moments, natural orbitals occupations or electrostatic potential
  * Composite methods like complete basis set extrapolation or G2/G3

Package: psi4-data
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Quantum Chemical Program Suite (data files)
 PSI4 is an ab-initio quantum chemistry program.  It is especially designed to
 accurately compute properties of small to medium molecules using highly
 correlated techniques. PSI4 is the parallelized successor of PSI3 and includes
 many state-of-the-art theoretical methods.
 .
 This package contains data files and the HTML documentation.
