=== debian/watch ===
version=3
https://github.com/psi4/psi4public/releases \
.*[^n]/(?:|v|version-|version|release-|r|REL_|rel-|y(?:_|-))(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
